package project.brain.component;
import javax.swing.tree.*;

import project.init.Layout;

import java.io.*;
import java.util.*;

public class OpinionsPerNode implements Serializable{

	private static final long serialVersionUID = 1L;
	
	private ArrayList<OpinionInfo> myOpinionList = new ArrayList<OpinionInfo>();
	private ArrayList<OpinionInfo> otherOpinionList = new ArrayList<OpinionInfo>();
	
	private DefaultMutableTreeNode node;
	private String nodeName;

	public OpinionsPerNode(DefaultMutableTreeNode node){
		this.node = node;
	}
	public DefaultMutableTreeNode getNode(){
		return node;
	}
	public void setMyOpinionList(String opinion){
		myOpinionList.add(new OpinionInfo(opinion));
	}
	public void setMyOpinionList(String userName, String opinion){
		opinion = "   " + opinion;
		if(myOpinionList.size() == 0){			
			opinion = "<br/><font size=5 color=red face=>"+userName +" ǰ<br/></font>" + opinion;
			myOpinionList.add(new OpinionInfo(userName, opinion));
			return;
		}
		myOpinionList.add(new OpinionInfo(opinion));
	}
	public void setMyOpinionList(ArrayList<OpinionInfo> myOpinionList){
		this.myOpinionList = myOpinionList;
	}
	public void setOtherOpinionList(ArrayList<OpinionInfo> otherOpinionList){
		this.otherOpinionList = otherOpinionList;
	}
	
	public void setOtherOpinionList(String userName, int position, String opinion){
		opinion = "   " + opinion;
		if(position != 0){
			for(int i=0; i<otherOpinionList.size(); i++){
				if(otherOpinionList.get(i).getUserName().equals(userName)){
					otherOpinionList.add(i+position, new OpinionInfo(opinion));
					break;
				}
			}
		}
		else{
			opinion =  "<br/><font size=5 color=red face=>"+userName +" ǰ<br/></font>" + opinion;
			otherOpinionList.add(new OpinionInfo(userName, opinion));
		}
	}
	
	public void setOtherOpinionAndSympathyInfo(String userName, String opinion, int count, String supporters, ArrayList<CommentInfo> commentList){
		otherOpinionList.add(new OpinionInfo(userName, opinion, count, supporters, commentList));
	}
	
	public static void viewAllOpinionPerNode(ArrayList<OpinionsPerNode> opinionList, int index){
		String msg="", tempMsg;
		int size = opinionList.get(index).getMyOpinionList().size();
		
		for(int i=0; i<size; i++){
			tempMsg = opinionList.get(index).getMyOpinionList().get(i).getOpinion();
			msg = msg + tempMsg + ":"+opinionList.get(index).getMyOpinionList().get(i).getCntSympathy()+"<br/>";
			int commentSize = opinionList.get(index).getMyOpinionList().get(i).getCommentList().size();
			for(int j=0; j<commentSize; j++){
				msg = msg + "   " +  opinionList.get(index).getMyOpinionList().get(i).getCommentList().get(j).getContent() +
				"("+opinionList.get(index).getMyOpinionList().get(i).getCommentList().get(j).getWriter()+")<br/>";
			}
		}

		size = opinionList.get(index).getOtherOpinionList().size();
		for(int i=0; i<size; i++){
			tempMsg = opinionList.get(index).getOtherOpinionList().get(i).getOpinion();
			msg = msg + tempMsg + ":"+opinionList.get(index).getOtherOpinionList().get(i).getCntSympathy()+"<br/>";
			int commentSize = opinionList.get(index).getOtherOpinionList().get(i).getCommentList().size();
			for(int j=0; j<commentSize; j++){
				msg = msg + "   " +  opinionList.get(index).getOtherOpinionList().get(i).getCommentList().get(j).getContent() +
				"("+opinionList.get(index).getOtherOpinionList().get(i).getCommentList().get(j).getWriter()+")<br/>";
			}
		}
		
		Layout.opinionOutputArea.setText(msg);
	}
	
	public boolean chkDuplMyOpinionSympathy(int position, String supporter){
		if(this.myOpinionList.get(position).supporter.indexOf(supporter) == -1)
			return true;
		else return false;
	}
	public boolean chkDuplOtherOpinionSympathy(String userName, int position, String supporter){
		for(int i=0; i<otherOpinionList.size(); i++){
			if(otherOpinionList.get(i).getOpinion().startsWith(userName)){}
			if(otherOpinionList.get(i).getUserName().equals(userName)){
				if(this.otherOpinionList.get(i+position).supporter.indexOf(supporter) == -1)
					return true;
				break;
			}
		}
		return false;
	}
	
	public void setMyOpinionSympathy(int position, String supporter){
		this.myOpinionList.get(position).cntSympathy++;
		this.myOpinionList.get(position).supporter += supporter;
	}

	public void setOtherOpinionSympathy(String userName, int position, String supporter){
		for(int i=0; i<otherOpinionList.size(); i++){
			if(otherOpinionList.get(i).getUserName().equals(userName)){
				this.otherOpinionList.get(i+position).cntSympathy++;
				this.otherOpinionList.get(i+position).supporter += supporter;
				break;
			}
		}
	}

	public void setMyOpinionComment(int position, String writer, String content){
		CommentInfo commentInfo = new CommentInfo(writer, content);
		myOpinionList.get(position).getCommentList().add(commentInfo);
	}
	public void setOtherOpinionComment(String userName, int position, String writer, String content){
		CommentInfo commentInfo = new CommentInfo(writer, content);
		for(int i=0; i<otherOpinionList.size(); i++){
			if(otherOpinionList.get(i).getUserName().equals(userName)){
				this.otherOpinionList.get(i+position).getCommentList().add(commentInfo);
			}
		}
	}
		
	public ArrayList<OpinionInfo> getMyOpinionList(){
		return myOpinionList;
	}
	public int getMyOpinionListSize(){
		return myOpinionList.size();
	}
	public ArrayList<OpinionInfo> getOtherOpinionList(){
		return otherOpinionList;
	}
	
	public void setNodeName(String nodeName){
		this.nodeName = nodeName;
	}
	public String getNodeName(){
		return nodeName;
	}
	
	class OpinionInfo implements Serializable{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		private String userName="";
		private String opinion;
		private int cntSympathy;
		private String supporter;
		private ArrayList<CommentInfo> commentList = new ArrayList<CommentInfo>();
		
		public OpinionInfo(String userName, String opinion){
			this.userName = userName;
			this.opinion=opinion;
			cntSympathy=0;
			supporter="";
		}
		
		public OpinionInfo(String opinion){
			this.opinion=opinion;
			cntSympathy=0;
			supporter="";
		}
		public OpinionInfo(String userName, String opinion, int count, String supporters, ArrayList<CommentInfo> commentList){
			this.userName=userName;
			this.opinion=opinion;
			cntSympathy=count;
			supporter=supporters;
			this.commentList = commentList;
		}
		
		public String getOpinion() {
			return opinion;
		}
		public void setOpinion(String opinion) {
			this.opinion += opinion;
		}
		public int getCntSympathy() {
			return cntSympathy;
		}
		public void setCntSympathy(int cntSympathy) {
			this.cntSympathy = cntSympathy;
		}
		public String getSupporter() {
			return supporter;
		}
		public void setSupporter(String supporter) {
			this.supporter = supporter;
		}
		public ArrayList<CommentInfo> getCommentList() {
			return commentList;
		}
		public void setCommentList(ArrayList<CommentInfo> commentList) {
			this.commentList = commentList;
		}

		public void setUserName(String userName) {
			this.userName = userName;
		}

		public String getUserName() {
			return userName;
		}
	}
	
	class CommentInfo implements Serializable{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		String content;
		String writer;
		
		public CommentInfo(String writer, String content){
			this.writer = writer;
			this.content = content;
		}
		public String getContent() {
			return content;
		}
		public void setContent(String content) {
			this.content = content;
		}
		public String getWriter() {
			return writer;
		}
		public void setWriter(String writer) {
			this.writer = writer;
		}
	}
}
