package project.brain.openapi;

import java.io.IOException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


public class DaumParse {
	private String apiKey = "3ba99aa1f2fb76c7e45014a34dfefe9b423ec8fc";
	                            
	public static String getContent(Element element, String tagName)
	{
		 NodeList list = element.getElementsByTagName(tagName);
		 Element cElement = (Element)list.item(0);
		 
		 try{
		 if(cElement.getFirstChild()!=null)
			return cElement.getFirstChild().getNodeValue();
		 }catch(NullPointerException e){
			 e.printStackTrace();
		 }
		return "";
	}
	
	public Category[] parse(int categoryNumber, String keyword, int pageNo)
	{
		String url="";
		switch(categoryNumber){
		case 1:
			url = "http://apis.daum.net/search/blog?q="+keyword+"&pageno="+pageNo+"&result=20&sort=accu&output=xml&apikey="+apiKey;
			break;
		case 2:
			url = "http://apis.daum.net/search/image?q="+keyword+"&pageno="+pageNo+"&result=20&output=xml&apikey="+apiKey;
			break;
		case 3:
			url = "http://apis.daum.net/search/vclip?q="+keyword+"&pageno="+pageNo+"&result=20&output=xml&apikey="+apiKey;
			break;
		case 4:
			url = "http://apis.daum.net/search/book?q="+keyword+"&pageno="+pageNo+"&result=20&sort=accu&output=xml&apikey="+apiKey;
			break;
		}
		
		try
		{
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = dbf.newDocumentBuilder();
			Document doc = builder.parse(url);
			Element root = doc.getDocumentElement();
			NodeList list = root.getElementsByTagName("item");

			switch(categoryNumber){
			case 1:
				DaumBlogSearchResult blogResult[] = new DaumBlogSearchResult[list.getLength()];
				for(int i=0; i<list.getLength();i++){
					blogResult[i] = new DaumBlogSearchResult(categoryNumber);
					Element element = (Element)list.item(i);
					blogResult[i].setTitle(getContent(element, "title"));
					url = getContent(element, "link");
					if(url.indexOf("?") != -1){
						blogResult[i].setLink(url.substring(0, url.indexOf("?")));	
					}else{
						blogResult[i].setLink(url);	
					}
					blogResult[i].setDescription(getContent(element, "description"));
					blogResult[i].setAuthor(getContent(element, "author"));
					blogResult[i].setPubDate(parseDate(getContent(element, "pubDate")));
				}
				return blogResult;
				
			case 2:
				DaumImageSearchResult imageResult[] = new DaumImageSearchResult[list.getLength()];
				for(int i=0; i<list.getLength();i++){
					imageResult[i] = new DaumImageSearchResult(categoryNumber);
					Element element = (Element)list.item(i);
					imageResult[i].setTitle(getContent(element, "title"));
					url = getContent(element, "link");
					if(url.indexOf("?") != -1){
						imageResult[i].setLink(url.substring(0, url.indexOf("?")));	
					}else{
						imageResult[i].setLink(url);	
					}
					imageResult[i].setAuthor(getContent(element, "author"));
					imageResult[i].setPubDate(parseDate(getContent(element, "pubDate")));
					imageResult[i].setThumbnail(getContent(element, "thumbnail"));
				}
				return imageResult;
			case 3:
				DaumKnowledgeSearchResult knowResult[] = new DaumKnowledgeSearchResult[list.getLength()];
				for(int i=0; i<list.getLength();i++){
					knowResult[i] = new DaumKnowledgeSearchResult(categoryNumber);
					Element element = (Element)list.item(i);
					knowResult[i].setTitle(getContent(element, "title"));
					url = getContent(element, "link");
					if(url.indexOf("?") != -1){
						knowResult[i].setLink(url.substring(0, url.indexOf("?")));	
					}else{
						knowResult[i].setLink(url);	
					}
					knowResult[i].setDescription(getContent(element, "description"));
					knowResult[i].setAuthor(getContent(element, "author"));
					knowResult[i].setPubDate(parseDate(getContent(element, "pubDate")));
				}
				return knowResult;
			case 4:
				DaumBookSearchResult bookResult[] = new DaumBookSearchResult[list.getLength()];
				for(int i=0; i<list.getLength();i++){
					bookResult[i] = new DaumBookSearchResult(categoryNumber);
					Element element = (Element)list.item(i);
					bookResult[i].setTitle(getContent(element, "title"));
					url = getContent(element, "link");
					if(url.indexOf("?") != -1){
						bookResult[i].setLink(url.substring(0, url.indexOf("?")));	
					}else{
						bookResult[i].setLink(url);	
					}
					bookResult[i].setDescription(getContent(element, "description"));
					bookResult[i].setAuthor(getContent(element, "author"));
					bookResult[i].setPubDate(parseDate(getContent(element, "pub_date")));
					bookResult[i].setCoverUrl(getContent(element, "cover_l_url"));
					bookResult[i].setPubCompany(getContent(element, "pub_nm"));
					bookResult[i].setCategory(getContent(element, "category"));
					bookResult[i].setSalePrice(getContent(element, "sale_price"));
				}
				return bookResult;
			}
		    
		}
		catch (Exception e)	{
			JOptionPane.showConfirmDialog(new JFrame(), "ͳ  θ Ȯּ.",
					"ͳ  ", JOptionPane.DEFAULT_OPTION);
			e.printStackTrace();
		}
		return null;
	}
	
	public String parseDate(String date){
		date = date.substring(0, 8);
		String tmp = date.substring(0,4) + "-";
		tmp += date.substring(4, 6) +"-";
		tmp += date.substring(6, 8);
		return tmp;
	}
}
